<template>
  <mind-view >
		<template v-slot:toolbar-actions>
      <el-button v-if="!modoEdicion" title="Activar Edición" @click="modoEdicion=!modoEdicion">
        <el-icon color="red">
          <Lock />
        </el-icon>
      </el-button>
      <el-button v-else title="Desactivar Edición" @click="modoEdicion=!modoEdicion">
        <el-icon color="green">
          <Unlock />
        </el-icon>
      </el-button>
      <el-button-group :disabled="!modoEdicion" style="display:flex">
        <ProjectSelect v-model="projectModel"  @change="onProjectSelected" :list="listaProyectos"/>
        <el-button
          :disabled="!projectModel||!modoEdicion"
          title="Editar Proyecto"
          type="primary"
          plain
          icon="Edit"
          @click="onProjectEdit()"
          style="padding:5px"
        />
        <el-button
          :disabled="!modoEdicion"
          type="primary"
          title="Crear Proyecto"
          plain
          icon="DocumentAdd"
          @click="onProjectCreate()"
          style="padding:5px"
        />
      </el-button-group>
      <div class="spacer-1" />
      <!--<el-checkbox-group
        v-model="modoEdicion"
        class="pa-0"
      >
        <el-checkbox-button :label="true">
          <el-icon>
            <Edit />
          </el-icon>
        </el-checkbox-button>
      </el-checkbox-group>-->

      <div class="spacer-1" />
      <ModeSelect v-model="herramientaActiva" :disabled="!projectModel||!modoEdicion"/>
      <div class="spacer-2" />
      <el-button
        type="primary" title="Propiedades del Espacio de Trabajo"
        plain
        icon="Setting"
        @click="onEditWorkspace()"
        >
      </el-button>
		</template>
    <div
      style="height:100%; width:100%; overflow: hidden">
      <el-row class="nowrap" style="height:100%; padding-bottom:2px">
        <el-col
          :span="24"
          >
          <div
            :style="{cursor: cursorActual, height: '100%', width: '100%'}"
          >
            <l-map
              ref="map"
              :use-global-leaflet="false"
              v-model:center="mapCenter"
              v-model:zoom="mapZoom"
              @click="addMarker"
            >
              <l-tile-layer
                url="https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png"
                layer-type="base"
                name="OpenStreetMap"
              ></l-tile-layer>
              <template>
                <MarkerNode
                  v-for=" v in puntosVisiblesNodos"
                  :id="v.id"
                  :accesspoint-info="v"
                  :draggable="modoEdicion"
                  @moveend="(e) => {moveAccessPoint(e, v)}"
                  @click="(e) => {editAccessPoint(e, v)}"
                />
              </template>
              <template>
                <MarkerCE
                  v-for=" v in puntosVisiblesCE"
                  :id="v.id"
                  :accesspoint-info="v"
                  :draggable="modoEdicion"
                  @moveend="(e) => {moveAccessPoint(e, v)}"
                  @click="(e) => {editAccessPoint(e, v)}"
                />
              </template>
              <template >
                <MarkerCTO
                  v-for=" v in puntosVisiblesCTO"
                  :id="v.id"
                  :accesspoint-info="v"
                  :draggable="modoEdicion"
                  @moveend="(e) => {moveAccessPoint(e, v)}"
                  @click="(e) => {editAccessPoint(e, v)}"
                />
              </template>
              <template>
                <MarkerCustomer
                  v-for=" v in puntosVisiblesCustomer"
                  :id="v.id"
                  :accesspoint-info="v"
                  :draggable="modoEdicion"
                  @moveend="(e) => {moveAccessPoint(e, v)}"
                  @click="(e) => {editAccessPoint(e, v)}"
                />
              </template>
              <template>
                <MarkerPole
                  v-for=" v in puntosVisiblesPole"
                  :id="v.id"
                  :accesspoint-info="v"
                  :draggable="modoEdicion"
                  @moveend="(e) => {moveAccessPoint(e, v)}"
                  @click="(e) => {editAccessPoint(e, v)}"
                />
              </template>

              <l-control position="bottomleft" >
                <ViewSelect v-model="elementosVisibles"/>
              </l-control>
            </l-map>
          </div>
        </el-col>
      </el-row>
    </div>
  </mind-view>
  <accesspoint-drawer
    v-model="accesspointModel"
    v-model:visible="accesspointVisible"
    v-model:editable="modoEdicion"
    @submit="onAccessPointSubmit">
  </accesspoint-drawer>
  <WorkspaceDialog
      v-model="workspaceModel"
      v-model:visible="dialogoWorkspaceVisible"
      @submit="onWorkspaceSubmit"
      :default-zoom="mapZoom"
      :defaultLong="mapCenter.lng"
      :defaultLat="mapCenter.lat"
      title="Propiedades del Espacio de Trabajo"
    />

    <ProjectDialog
      v-model="projectModel"
      v-model:visible="dialogoProyectoVisible"
      @submit="onProjectSubmit"
      :default-zoom="mapZoom"
      :defaultLong="mapCenter.lng"
      :defaultLat="mapCenter.lat"
      title="Propiedades del Proyecto"
    />

</template>

<script setup>
// vue
import { ref, onMounted, computed,watchEffect } from 'vue'
import {  useRoute } from 'vue-router'


// mapa
import "leaflet/dist/leaflet.css";
import L, { LatLng } from "leaflet";
import { LMap, LTileLayer, LControl, LControlLayers } from "@vue-leaflet/vue-leaflet";
import {MarkerNode,MarkerCE,MarkerCTO,MarkerCustomer,MarkerPole} from "@components/map"

// componentes y composables
import {ModeSelect, ViewSelect} from "@components/toolbar"
import {WorkspaceDialog, ProjectDialog, ProjectSelect, AccesspointDrawer} from '@/components'
import {useWorkspace, useProject, useAccessPoint, useTools} from '@/composables/'


// router
const route = useRoute()

/* ************************** Cursores */
const {tools, defaultTool} = useTools()
const cursorActual = computed(() => {
  let  cursor
  if(herramientaActiva.value == null) {
    cursor = `${defaultTool.pointer}`
  }

  cursor = `${herramientaActiva.value.pointer} !important`

  return cursor
})



/* ************************** Mapa  */
const herramientaActiva = ref(defaultTool)
const elementosVisibles = ref(['node', 'ce', 'cto'])
const map = ref(null);
const mapZoom = ref(5)
const mapCenter = ref({
        lat: -34,
        lng: -58
      })

/* ************************** Workspace  */
const {getWorkspace, updateWorkspace} = useWorkspace()
const workspaceID = route.params.id
const workspaceModel = ref(null)
const modoEdicion = ref (false)
const dialogoWorkspaceVisible = ref(false)
function onEditWorkspace() {
  dialogoWorkspaceVisible.value = true
}

watchEffect(() => {
  if(!modoEdicion.value){
    herramientaActiva.value= defaultTool
  }
})

async function onWorkspaceSubmit(v) {
  try {
    const response = await updateWorkspace(v)
    workspaceModel.value = response
    dialogoWorkspaceVisible.value = false
  } catch(err) {
    alert(err)
  }
}

function centerWorkspace() {
  const latLng = L.latLng(workspaceModel.value.lat, workspaceModel.value.lng)
  const zoom = workspaceModel.value.zoom
  if(map.value.leafletObject && map.value.leafletObject.flyTo) {
    map.value.leafletObject.flyTo(latLng, zoom)
  } else {
    mapCenter.value = latLng
    setTimeout(() => {
      mapZoom.value = zoom
    }, 400)
  }

}

/* ************************** Proyectos  */
const projectModel = ref(null)
const dialogoProyectoVisible = ref(false)
const {state: listaProyectos, fetchProjects, updateProject, newEmptyProject, createProject } = useProject()
async function onProjectSelected(selecteProject) {
  const id = selecteProject.id
  centerProject()
  await fetchAccessPoints(workspaceID, id)
}

async function onProjectEdit() {
  dialogoProyectoVisible.value = true
}

async function onProjectCreate() {
  projectModel.value = newEmptyProject(workspaceModel.value.id)
  dialogoProyectoVisible.value = true
}

async function onProjectSubmit(v) {
  try {
    if(v.id) {
      const response = await updateProject(v)
      projectModel.value = response
    } else {
      const response = await createProject(v)
      projectModel.value = response.shift()
    }
    dialogoProyectoVisible.value = false
  } catch(err) {
    alert(err)
  }
  await fetchProjects(workspaceID)

  dialogoProyectoVisible.value = false
}

function centerProject() {
  const latLng = L.latLng(projectModel.value.lat, projectModel.value.lng)
  const zoom = projectModel.value.zoom
  map.value.leafletObject.flyTo(latLng, zoom)
}


/* ************************** Puntos de Acceso  */
const {fetchAccessPoints, createAccessPoint, nodeList, ceList, ctoList, customerList, updateAccessPoint, poleList} = useAccessPoint()

const accesspointModel = ref(null)
const accesspointVisible = ref(false)

const puntosVisiblesNodos = computed(() => {
  return nodeList.value.filter((ap) => {
    return elementosVisibles.value.includes(ap.type)
  })
})

const puntosVisiblesCE = computed(() => {
  return ceList.value.filter((ap) => {
    return elementosVisibles.value.includes(ap.type)
  })
})

const puntosVisiblesCTO = computed(() => {
  return ctoList.value.filter((ap) => {
    return elementosVisibles.value.includes(ap.type)
  })
})

const puntosVisiblesCustomer = computed(() => {
  return customerList.value.filter((ap) => {
    return elementosVisibles.value.includes(ap.type)
  })
})


const puntosVisiblesPole = computed(() => {
  return poleList.value.filter((ap) => {
    return elementosVisibles.value.includes(ap.type)
  })
})

function editAccessPoint(e, m) {
  accesspointModel.value = m
  accesspointVisible.value = true

}

async function moveAccessPoint(m,v){
  const workspaceID = workspaceModel.value.id
  const projectID = projectModel.value.id
  const ap={
    id:v.id,
    lat:m.target._latlng.lat,
    lng:m.target._latlng.lng,
    workspaceID: workspaceID,
    projectID:projectID
  }
  await updateAccessPoint(ap)
  await fetchAccessPoints(workspaceID, projectID)
}

async function onAccessPointSubmit(v){
  const workspaceID = workspaceModel.value.id
  v.workspaceID = workspaceID
  updateAccessPoint(v)
}

function addMarker(e) {
  const latLng = e.latlng
  const type = herramientaActiva.value.type
  if(type == 'pointer') {
    return
  }
  const workspaceID = workspaceModel.value.id
  const projectID = projectModel.value.id

  const ap = createAccessPoint({
    workspaceID,
    projectID,
    name: "",
    type: type,
    lat: latLng.lat,
    lng: latLng.lng
  })

}


/* ************************** Hooks  */
onMounted(async ()=>{
  try {
    const ws = await getWorkspace(workspaceID)
    workspaceModel.value = ws
    setTimeout(() => {
      centerWorkspace()
    }, 500)
  } catch(err) {
  }

  await fetchProjects(workspaceID)
})


</script>

<style scoped>
.nowrap {
  flex-wrap: nowrap;
}
.spacer-1 {
  width: 10px;
}

.spacer-2 {
  flex-grow: 1;
}

#crosshair {
  z-index: 10000;
  cursor: pointer;
}
.leaflet-container.crosshair-cursor-enabled {
    cursor:crosshair;
}
</style>

<style>
.leaflet-grab {
  cursor:inherit;
}
</style>